"""
Modul pro generování Fibonacciho posloupnosti.
"""

from typing import List

def fib(n: int) -> List[int]:
    """Vrať prvních n prvků Fibonacciho posloupnosti.
    >>> fib(5)
    [1, 1, 2, 3 ,5]
    """
    result = []
    a, b = 1, 1
    while len(result) < n:
        result.append(a)
        a, b = b, a+b
    return result

def main() -> None:
    """Interaktivní výpis Fibonacciho posloupnosti."""
    pocet = int(input('Zadej požadovaný počet prvků: '))
    posloupnost = fib(pocet)
    print(*posloupnost, sep=', ')

if __name__ == '__main__':
    main()
